
#include<windows.h>
#include<cstdio>
#include <algorithm>
#include <csetjmp> 
using namespace std;

int N,M,P,A,comb;
int F[51][51], tempF[51][51];
int temp_ani[12],temp_null[12],sum;
int tr[12], tc[12],saveF[51][51];
int time_on, val;
jmp_buf env;

struct animals{
	int r,c,k,t,basic_p,n;
	struct position{
		int r,c;
	} p[101];
	bool operator < (animals const &a) const {return (this->n > a.n);}
} ani[101];

struct result{
	int r,c,p,null;
} R[101];

void NewF(int p, int i, int j){
	int s;
	for(s=1; s<=ani[p].n; s++){
		F[i+ani[p].p[s].r][j+ani[p].p[s].c] /= ani[p].k;
	}
}
void SaveTempF(){
	int i,j;
	for(i=1; i<=N; i++){
		for(j=1; j<=M; j++){
			saveF[i][j] = tempF[i][j];
		}
	}
}
bool TestLowSecurity(int p, int i, int j){           
	int s;
	for(s=1; s<=ani[p].n; s++){
		if(tempF[i+ani[p].p[s].r][j+ani[p].p[s].c] < ani[p].t){ return true;}
	}
	return false;
}
int CalSecurity(int p, int i, int j){    
	int s, cal = 0;
	for(s=1; s<=ani[p].n; s++){
		cal += tempF[i+ani[p].p[s].r][j+ani[p].p[s].c];
	}
	return cal;
}
void NewTempF(int p, int i, int j){
	int s;
	for(s=1; s<=ani[p].n; s++){
		tempF[i+ani[p].p[s].r][j+ani[p].p[s].c] /= ani[p].k;
	}
}
void SetTemp_ani(int beg, int size){
	int i;
	for(i=1; i<=size; i++){
		temp_ani[i] = beg + i - 1;
	}
}
void SetTempF(){
	int i,j;
	for(i=1; i<=N; i++){
		for(j=1; j<=M; j++){
			tempF[i][j] = F[i][j];
		}
	}
}
void RecoveryTempF(){
	int i,j;
	for(i=1; i<=N; i++){
		for(j=1; j<=M; j++){
			tempF[i][j] = saveF[i][j];
		}
	}
}
void SearchMaxSum(){   
	int p,i,j,ti,tj,security, tem_security, temp_sum = 0;
	SetTempF(); for(p=1; p<=comb; p++) temp_null[p] = 0;
	for(p=1; p<=comb; p++){
		security = 0; tem_security = 0;
		for(i=1; i<=N-ani[temp_ani[p]].r+1; i++){
			for(j=1; j<=M-ani[temp_ani[p]].c+1; j++){
				if(TestLowSecurity(temp_ani[p],i,j)) continue;
				security = CalSecurity(temp_ani[p],i,j); if(security < tem_security) continue;
				tem_security = security; ti = i; tj = j; 
			}
		}
		if(tem_security == 0){temp_null[p]++; continue;}
		temp_sum += tem_security;
		tr[p] = ti; tc[p] = tj; 
		NewTempF(temp_ani[p],ti,tj);
	}
	if(temp_sum > sum){ 
		sum = temp_sum;  SaveTempF();
		for(p=1; p<=comb; p++){
			R[p].r = tr[p]; R[p].c = tc[p]; R[p].null = temp_null[p];
			R[p].p = ani[temp_ani[p]].basic_p;  
		}     
	}
}
void Comb(int k){
	int i,v;
	if(k == 0) {SearchMaxSum(); if(GetTickCount()-time_on >1920) longjmp(env,1);}
	else{
		Comb(k-1);
		for(i=1; i<k; i++){
			v = temp_ani[i]; temp_ani[i] = temp_ani[k]; temp_ani[k] = v;
			Comb(k-1);
			v = temp_ani[i]; temp_ani[i] = temp_ani[k]; temp_ani[k] = v;
		}
	}
} 
void Input(){
	int n,m,p,i,j,v,eff,corr=0;
	char x;
	FILE *in = fopen("parash.in", "r");
	fscanf(in,"%d %d %d\n", &N, &M, &P);
	for(n=1; n<=N; n++){
		for(m=1; m<=M; m++){
			fscanf(in, "%d ", &F[n][m]);
		}
	}
	SetTempF(); SaveTempF();
	for(p=1; p<=P; p++){
		fscanf(in,"%d %d %d %d\n",&ani[p-corr].r,&ani[p-corr].c,&ani[p-corr].k,&ani[p-corr].t);
		eff=0;
		for(i=0; i<ani[p-corr].r; i++){
			for(j=0; j<ani[p-corr].c; j++){
				fscanf(in, "%c", &x); if(x == '0') continue;
				eff++; ani[p-corr].p[eff].r = i; ani[p-corr].p[eff].c = j; 
			}
			fscanf(in, "\n"); 
		}
		ani[p-corr].n = eff; ani[p-corr].basic_p = p; v=0;
		for(i=1; i<=N-ani[p-corr].r+1; i++){
			for(j=1; j<=M-ani[p-corr].c+1; j++){
				if(!TestLowSecurity(p-corr,i,j)) {v++; break;}	
			}
			if(v>0) break;
		}
		if(v==0) corr++; 
	}
	P -= corr;
	fclose(in);         
}
void Output(){
	FILE *out = fopen("parash.out","w");
	fprintf(out,"%d\n", A);
	for(int i=1; i<=P; i++){
		if(R[i].null) continue;
		fprintf(out,"%d %d %d\n", R[i].p, R[i].r, R[i].c);
	}
	fclose(out);
}
void AfterComb(int comb){ 
	int p,i,j,ti,tj,security, tem_security;
	for(p=comb+1; p<=P; p++){
		security = 0; tem_security = 0;
		for(i=1; i<=N-ani[p].r+1; i++){
			for(j=1; j<=M-ani[p].c+1; j++){
				if(TestLowSecurity(p,i,j)) continue;
				security = CalSecurity(p,i,j); if(security <= tem_security) continue;
				tem_security = security; ti = i; tj = j;
			}
		}
		if(tem_security == 0) {R[p].null++; continue;}
		R[p].r = ti; R[p].c = tj; R[p].p = ani[p].basic_p;
		NewTempF(p,ti,tj); A++;
	} 
	Output();
}

int main(){ 
	time_on = GetTickCount();
	Input();
	sort(&ani[1], &ani[P+1]);
	comb = 10;
	if(P < 10) comb = P;
	SetTemp_ani(1,comb);
	val=setjmp(env);
	if(!val) Comb(comb);
	for(int i=1; i<=comb; i++) if(!R[i].null) A++;
	RecoveryTempF();
	AfterComb(comb);
	return 0;
}